extends ../includes/layout
block content
    style. 
        .btn-w{
            width:150px;
        }
    .row.page-titles.my-3
        ol.breadcrumb
            li.breadcrumb-item.active
                a(href=base_url+'home') Auction
            li.breadcrumb-item
                a(href='javascript:void(0)')=data.name

    .row
        .col-lg-12
            .card
                .card-body
                    .row
                        .col-xl-9.col-lg-6.col-md-6.col-xxl-7.col-sm-12
                            .product-detail-content
                                // Product details
                                .new-arrival-content.pr
                                    h4=data.name
                                    .d-table.mb-2
                                        p.price.float-start.d-block(data-room=data._id)#h4display='฿ '+data.startPrice

                                    h4.m-b-15#countdown Count Down
                                    h4.m-b-15#contentRound(data-round="0") Round

                                    .d-flex.align-items-end.flex-wrap.mt-4
                                        .shopping-cart.mb-2.me-3
                                            button.btn.btn-primary.btn-w#btnBid(data-room=data._id data-price=data.startPrice)
                                                i.fa.fa-plus.me-2  Accept
                                            button.btn.btn-info#btn_cancel.l-5.hide(data-room=data._id data-price=data.startPrice) Cancel


                            h5.mx-3 History
                            .table-responsive
                                table.table.table-sm.mb-0
                                    thead
                                        tr
                                            th.align-middle.text-end Round
                                            th.align-middle.text-end Price
                                    tbody#content

block script
    script(src='/socket.io/socket.io.js')
    script.
        var socket = io()
        var cur_price
        let messages = []
        let bidder
        var room = $('#btnBid').data('room')
        var accept_first = false
        var cur_round = 0;

        load_product()

        socket.emit("join", room);

        $('#btn_cancel').click(function(){
            
            sweetAlert({
                title: "Confirm",
                text: "your cancel bid current price",
                type: "warning",
                showCancelButton: true,
            })
            .then(confirm => {
                if (confirm.value == true) {
                    socket.emit("join", room);
                    socket.emit('cancel_bid', room,{user_id,cur_round},function (res) {
                        console.log(res)
                       
                        $('#content #round'+cur_round).remove();
                        $('#btnBid').html('Accept').prop("disabled",false);
                        $('#btn_cancel').hide()
                    });
                }
            });
        })

        socket.on('count_room', function(obj) {
            if(obj.count == 'process'){
                //- socket.emit('setBid', room,'pull',{user_id,name,email},function(res){
                //-     console.log('respon count room',res)
                //- });
                $('#btnBid').prop("disabled",true);
            }

            if(cur_round!=obj.round){
                cur_round = obj.round
                load_product()
            }
            $('#countdown').text('Count Down '+obj.count)
            $('#contentRound').text('Round '+obj.round)
            $('#contentRound').attr('data-round',obj.round)
        });

        socket.on("connect", function () {
            // Connected, let's sign-up for to receive messages for this room
            console.log("connect");
            load_product()
        });

        socket.on("disconnect", function () {
            // Connected, let's sign-up for to receive messages for this room
            console.log("disconnect");
            // socket.emit('room', room);
        });

        socket.emit('setBid', room,'pull',{user_id,name,email},function(res){
            console.log('respon count room',res)
        });

        socket.on('setBid', function(message) {
            if(message.allBids){
                console.log('sadasdasdasd',message);
                if(message.allBids.round.length > 0){
                    cur_price = parseInt(message.allBids.cur_Price);
                }else{
                    cur_price = parseInt(message.allBids.startPrice);
                }

                $("#contentRound").text("Round "+message.allBids.round_slug);
                $("#Winner").text(message.user.name);
                $("#btnBid[data-room='" + message.room +"']").attr('data-price',cur_price)
                $("#h4display[data-room='" + message.room +"']").text('฿ '+cur_price)

                console.log('append new price',cur_price);
                messages = message.allBids;
                bidder = message.allBids.round[message.allBids.round_slug]

                let winnerID;
                if(bidder){
                    winnerID = bidder.find(o => o.user_id === user_id);
                }
                console.log('winnerID',winnerID)
                if(winnerID !== undefined){
                    $('#btnBid').html('Accepted').prop("disabled",true);

                    $('#btn_cancel').show();
                }else{
                    $('#btnBid').html('Accept').prop("disabled",false);

                    $('#btn_cancel').hide();
                }

                filterMessage();
            }
        });

        $('#btnBid').click(function(){
            socket.emit("join", room);
            cur_price = parseInt($(this).attr('data-price'));
            let winnerID;
            console.log('bidder',bidder)
            if(bidder){
                winnerID = bidder.find(o => o.user_id === user_id);
            }
            var check = $('#content .list_round:last').attr('data-round')
            var contentRound = $('#contentRound').attr('data-round')
            console.log(check)
            console.log(contentRound)
            console.log('cur_round',cur_round)

            //- if(winnerID !== undefined){
            //-     sweetAlert("Oops...", "Yor max price[0]", "error");
            //- }else 
            if(check == contentRound){
                sweetAlert("Oops...", "Yor max price", "error");
            }else if(accept_first == false && cur_round != 0){
                sweetAlert("Oops...", "Access denied", "error");
            }else{
                sweetAlert({
                    title: "Confirm",
                    text: "your confirm price at "+cur_price,
                    type: "warning",
                    showCancelButton: true,
                })
                .then(confirm => {
                    //console.log(confirm)
                    if (confirm.value == true) {
                        socket.emit('setBid', room,'bid',{user_id,name,email,cur_round},function (res) {
                            console.log(res)
                            if(res=='wait'){
                                sweetAlert("Alert", "Product wait");
                                $('#btnBid').prop('disabled',false)
                            }else if(res=='pause'){
                                sweetAlert("Alert", "Product pause");
                                $('#btnBid').prop('disabled',false)
                            }else if(res=='not_respon'){
                                console.log('data not respon')
                            }else{
                                sweetAlert("Success", "Your price "+cur_price, "success");
                            }
                        });
                    }
                });
            }
        })

        function load_product(){
            $.ajax({
                url: "#{base_url}auction/product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    id:room
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        console.log(res.data.round)
                        console.log(user_id)
                        cur_round = res.data.round_slug
                        set_default_mesasge(res.data.round,res.data.round_slug)

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    alert_error(xhr,error)
                },
            });
        }

        function set_default_mesasge(data,round_slug){
            $('#content').empty()
            $(data).each(function(key,val){
                if(val){
                    console.log('have data')
                    $(val).each(function(key,val){
                        if(user_id==val.user_id && val.status=='approve'){
                            accept_first = true
                            console.log(round_slug)
                            console.log(val.round)
                            element_bid(val.round,val.bid)
                        }
                    })   
                }else{
                    console.log('no data')
                }
            })
        }

        function element_bid(round,bid){
            var html = ''
            html += '<tr id="round'+round+'">'
            html += '<td class="py-2 text-end list_round" data-round="'+round+'">'+(round == 0?'Accepted First Price':round)+'</td>'
            html += '<td class="py-2 text-end">'+bid+'</td>'
            html += '</tr>'
            $('#content').append(html)
            accpess_btn_bid()
        }

        function accpess_btn_bid(){
            console.log('accpess_btn_bid')

            var check = $('#content .list_round:last').attr('data-round')
            var contentRound = $('#contentRound').attr('data-round')

            console.log(check)
            console.log(contentRound)
            if(check==contentRound || check==cur_round){
                $('#btnBid').html('Accepted').prop("disabled",true);

                $('#btn_cancel').show();
            }else{
                $('#btnBid').html('Accept').prop("disabled",false);

                $('#btn_cancel').hide();
            }
        }

        function filterMessage(){
            $('#content').empty()
            let history = [];
            for(var i = 0; i <= messages.round_max; i++){
                if(messages.round[i]){
                    console.log(messages.round[i]);
                    var dd = messages.round[i].find(o => o.user_id === user_id)
                    if(dd !== undefined){
                        history.push(dd);
                    }
                }
            }
            $.each(history,function(index,value){

                element_bid(value.round,value.bid)
            })

        }